local size = 22;
local width = 100;

table.insert(layouts, {
	name = "Line",

	width = size * 11 + width,
	height = size,

	post = function(window)
		if window.petclass ~= nil then
			local triangle = Turbine.UI.Control();

			triangle:SetZOrder(2);
			triangle:SetParent(window);
			triangle:SetPosition(0, 0);
			triangle:SetSize(size, size);
			triangle:SetVisible(true);
			triangle:SetMouseVisible(false);
			triangle:SetBackground("moebius92/PartyFrame/res/triangle.tga");
			triangle:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply);
			triangle.opacity = 1.0;
			table.insert(window.controls[1].controls, triangle);
		end
	end,

	layout = {
		{
			name = "Background",
			label = { en = "Background", de = "Hintergrund", fr = "Arri\195\168re-plan" },
			element = PMCBackground,
			settings = { opacity = 0.3 },
			default = {
				color = {
					{ color = { R = 0.5, G = 0.3, B = 0.1 }, "[beorning]" },
					{ color = { R = 0.0, G = 0.0, B = 0.0 }, "[burglar]" },
					{ color = { R = 0.0, G = 0.0, B = 1.0 }, "[captain]" },
					{ color = { R = 1.0, G = 0.0, B = 0.0 }, "[champion]" },
					{ color = { R = 1.0, G = 0.5, B = 0.0 }, "[guardian]" },
					{ color = { R = 0.0, G = 1.0, B = 0.0 }, "[hunter]" },
					{ color = { R = 0.0, G = 1.0, B = 1.0 }, "[lore master]" },
					{ color = { R = 1.0, G = 1.0, B = 0.0 }, "[minstrel]" },
					{ color = { R = 1.0, G = 1.0, B = 1.0 }, "[rune keeper]" },
					{ color = { R = 1.0, G = 0.0, B = 1.0 }, "[warden]" }
				}
			}
		},

		{
			name = "Name",
			label = { en = "Name", de = "Name", fr = "Nom" },
			element = PMCName,
			settings = { x = size, y = 0, z = 1, w = size * 5, h = size },
			default = {
				order = true,
				color = {
					{ color = { H = nil, S = nil, V = 0.0 }, "[morale] <= 0" },
					{ color = { R = 1.0, G = 0.0, B = 0.0 }, "[linkdead]" },
					{ color = { R = 1.0, G = 0.7, B = 0.0 }, "[target]" },
					{ color = { R = 0.0, G = 1.0, B = 0.0 }, "[voice]" },
					{ color = { R = 1.0, G = 1.0, B = 1.0 }, "[default]" }
				}
			}
		},

		{
			name = "Morale",
			label = { en = "Morale", de = "Moral", fr = "Moral" },
			element = PMCMorale,
			settings = { x = size * 6 + 1, y = 3, z = 1, w = width - 2, h = (size - 6) / 2 },
			default = { threat = 5 }
		},

		{
			name = "Power",
			label = { en = "Power", de = "Kraft", fr = "Puissance" },
			element = PMCPower,
			settings = { x = size * 6 + 1, y = size / 2, z = 1, w = width - 2, h = (size - 6) / 2 },
			default = { fill = 0 }
		},

		{
			name = "R",
			element = PMCSquare,
			settings = { x = size / 4, y = size / 4, z = 1, w = size / 2, h = size / 2 },
			default = {
				color = {
					{ color = { H = nil, S = nil, V = 0.0 }, "[member]" },
					{ color = { H = 4.0, S = 1.0, V = nil }, "[talking]" },
					{ color = { R = 0.0, G = 1.0, B = 0.0 }, "[ready]" },
					{ color = { R = 1.0, G = 0.0, B = 0.0 }, "[not ready]" },
					{ color = { R = 1.0, G = 1.0, B = 1.0 }, "[unknown ready]" }
				}
			}
		},

		{
			name = "L1",
			element = PMCEffect,
			settings = { x = size * 1, y = 0, z = 2, w = size, h = size },
			default = {
				missing = false,
				effectDuration = 10,
				color = {
					{
						color = { },
						"Dazed", "Feared", "Knocked Down", "Knocked Out", "Recovering", "Rooted", "Stunned", "Vulnerable"
					}
				}
			}
		},

		{
			name = "L2",
			element = PMCEffect,
			settings = { x = size * 2, y = 0, z = 2, w = size, h = size },
			default = {
				missing = false,
				effectDuration = 10,
				color = {
					{ color = { }, "<curable fear>" }
				}
			}
		},

		{
			name = "L3",
			element = PMCEffect,
			settings = { x = size * 3, y = 0, z = 2, w = size, h = size },
			default = {
				missing = false,
				effectDuration = 10,
				color = {
					{ color = { }, "<curable wound>" }
				}
			}
		},

		{
			name = "L4",
			element = PMCEffect,
			settings = { x = size * 4, y = 0, z = 2, w = size, h = size },
			default = {
				missing = false,
				effectDuration = 10,
				color = {
					{ color = { }, "<curable disease>" }
				}
			}
		},

		{
			name = "L5",
			element = PMCEffect,
			settings = { x = size * 5, y = 0, z = 2, w = size, h = size },
			default = {
				missing = false,
				effectDuration = 10,
				color = {
					{ color = { }, "<curable poison>" }
				}
			}
		},

		{
			name = "R1",
			element = PMCEffect,
			settings = { x = width + size * 6, y = 0, z = 2, w = size, h = size },
			default = {
				missing = false,
				effectDuration = 0,
				color = { }
			}
		},

		{
			name = "R2",
			element = PMCEffect,
			settings = { x = width + size * 7, y = 0, z = 2, w = size, h = size },
			default = {
				missing = false,
				effectDuration = 0,
				color = { }
			}
		},

		{
			name = "R3",
			element = PMCEffect,
			settings = { x = width + size * 8, y = 0, z = 2, w = size, h = size },
			default = {
				missing = false,
				effectDuration = 0,
				color = { }
			}
		},

		{
			name = "R4",
			element = PMCEffect,
			settings = { x = width + size * 9, y = 0, z = 2, w = size, h = size },
			default = {
				missing = false,
				effectDuration = 0,
				color = { }
			}
		},


		{
			name = "R5",
			element = PMCEffect,
			settings = { x = width + size * 10, y = 0, z = 2, w = size, h = size },
			default = {
				missing = false;
				effectDuration = 0,
				color = { }
			}
		}
	},

	class = {
		[Turbine.Gameplay.Class.Beorning] = {
			R1 = { color = { { color = { }, "Vicious Rage" }, { color = { }, "Mark of Grimbeorn" } } },
			R2 = { color = { { color = { }, "Nature's Bond" } } },
			R3 = { effectDuration = 10, color = { { color = { }, count = -1, "<curable disease>", "<curable fear>", "<curable poison>", "<curable wound>" } } },
			R4 = { effectDuration = 10, color = { { color = { }, count = -2, "<curable disease>", "<curable fear>", "<curable poison>", "<curable wound>" } } },
			R5 = { effectDuration = 10, color = { { color = { }, count = -3, "<curable disease>", "<curable fear>", "<curable poison>", "<curable wound>" } } }
		},

		[Turbine.Gameplay.Class.Burglar] = {
			R1 = { color = { { color = { }, "Signal: Conviction", "Signal: Guile", "Signal: Strength", "Signal: Tactics" } } },
			R5 = { effectDuration = 10, color = { { color = { }, count = -1, "<curable disease>", "<curable fear>", "<curable poison>", "<curable wound>" } } }
		},

		[Turbine.Gameplay.Class.Captain] = {
			R1 = { color = { { color = { }, "Blade-brother", "Shield-brother", "Song-brother", "Watchful Shield-brother" } } },
			R2 = { color = { { color = { }, "Words of Courage" } } },
			R3 = { color = { { color = { }, "Rousing Cry Damage Buff" } } },
			R4 = { color = { { color = { }, "Penetrating Cry Attack Speed Buff" } } },
			R5 = { effectDuration = 10,
			       color = { { color = { }, count = -1, "<curable disease>", "<curable fear>", "<curable poison>", "<curable wound>" },
				             { color = { }, "Focus", "On Guard", "Relentless Attack" } } }
		},

		[Turbine.Gameplay.Class.Champion] = { },

		[Turbine.Gameplay.Class.Guardian] = {
			R1 = { color = { { color = { }, "Protection", "Protection by the Sword", "Shield Wall" } } }
		},

		[Turbine.Gameplay.Class.Hunter] = {
			R1 = { color = { { color = { }, "Find the Path" } } },
			R2 = { color = { { color = { }, "Cleanse Poison Resistance" } } },
			R3 = { effectDuration = 10, color = { { color = { }, count = -1, "<curable poison>" } } },
			R4 = { effectDuration = 10, color = { { color = { }, count = -2, "<curable poison>" } } },
			R5 = { effectDuration = 10, color = { { color = { }, count = -3, "<curable poison>" } } }
		},

		[Turbine.Gameplay.Class.LoreMaster] = {
			R1 = { color = { { color = { }, "Temporary State Immunity" }, { color = { }, "Charged Air" } } },
			R2 = { color = { { color = { }, "Water-lore" } } },
			R3 = { effectDuration = 10, color = { { color = { }, count = -1, "<curable disease>", "<curable fear>", "<curable poison>", "<curable wound>" } } },
			R4 = { effectDuration = 10, color = { { color = { }, count = -2, "<curable disease>", "<curable fear>", "<curable poison>", "<curable wound>" } } },
			R5 = { effectDuration = 10, color = { { color = { }, count = -3, "<curable disease>", "<curable fear>", "<curable poison>", "<curable wound>" } } }
		},

		[Turbine.Gameplay.Class.Minstrel] = {
			R1 = {
				color = {
					{ color = { }, "Defiance", "Guardian's Pledge", "Last Stand" },
					{ color = { }, "Improved Soliloquy of Spirit", "Soliloquy of Spirit" },
					{ color = { }, "The Melody of Battle" }
				}
			},

			R2 = { color = { { color = { }, "Anthem of War" } } },
			R3 = { color = { { color = { }, "Anthem of Composure" } } },
			R4 = { color = { { color = { }, "Anthem of Prowess" } } },
			R5 = { effectDuration = 10, color = { { color = { }, count = -1, "<curable disease>", "<curable fear>", "<curable poison>", "<curable wound>" } } }
		},

		[Turbine.Gameplay.Class.RuneKeeper] = {
			R1 = {
				color = {
					{ color = { }, "Defiance", "Guardian's Pledge", "Last Stand" },
					{ color = { }, "Frost Armour" },
				}
			},

			R2 = { color = { { color = { }, "Mending Verse" } } },
			R3 = { color = { { color = { }, "Writ of Health - Tier 1", "Writ of Health - Tier 2", "Writ of Health - Tier 3" } } },
			R4 = { color = { { color = { }, "Bombastic Inspiration - Tier 1", "Bombastic Inspiration - Tier 2", "Bombastic Inspiration - Tier 3" } } },
			R5 = { color = { { color = { }, "Prelude to Hope", "Do Not Fall This Day" } } }
		},

		[Turbine.Gameplay.Class.Warden] = {
			R1 = { color = { { color = { }, "Conviction" } } },
			R2 = { color = { { color = { }, "Conviction - Physical Mastery", "Conviction - Threat Reduction" } } }
		}
	}
});