import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "moebius92.ColorBar";
import "moebius92.Handlers";
import "moebius92.Misc";

import "moebius92.PartyFrame.LayoutInit";

import "moebius92.PartyFrame.Layout.Line";
import "moebius92.PartyFrame.Layout.Grid";

import "moebius92.PartyFrame.StringResources";

import "moebius92.PartyFrame.PartyFrameWindow";
import "moebius92.PartyFrame.PartyFrameCommand";

local reload = Turbine.UI.Control();
reload.state = 0;
function reload:Update()
	if self.state == 0 then
		Turbine.PluginManager.UnloadScriptState("PartyFrameReloader");
	elseif self.state > 0 then
		self:SetWantsUpdates(false);
		reload = nil;
	end

	self.state = self.state + 1;
end
reload:SetWantsUpdates(true);

function plugin:Load(args)
	self.suppress = Turbine.UI.Lotro.LotroUI.IsEnabled(Turbine.UI.Lotro.LotroUIElement.Party);

	self.window = PartyFrameWindow(self:GetVersion());
	self.command = PartyFrameCommand(self);
	Turbine.Shell.AddCommand(string.lower(self:GetName()), self.command);
	Turbine.Shell.AddCommand(S.CommandCommandS, self.command);

	local state = Turbine.PluginData.Load(Turbine.DataScope.Account, "PartyFrame");
	if type(state) == "string" then
		state = loadstring("return " .. state .. ";")();
	end
	if state ~= nil and (Turbine.Engine.GetLocalTime() - state.time) < 15 then
		self.window.restart = true;
		self.window.fellowship = state.fellowship;
		self.window.grid = state.grid;
		self.window:PartyMemberChanged();
		self.window:SetMove(state.move);
		self.window:SetHide(state.hide);
	end
end

function plugin:Unload(args)
	local state = { };

	if self.window.reload then
		state.time = Turbine.Engine.GetLocalTime();
		state.fellowship = self.window.fellowship;
		state.grid = self.window.grid;
		state.move = self.window.move;
		state.hide = self.window.hide;
		Turbine.PluginData.Save(Turbine.DataScope.Account, "PartyFrame", serialize(state));
	end

	Turbine.UI.Lotro.LotroUI.SetEnabled(Turbine.UI.Lotro.LotroUIElement.Party, self.suppress);
end

function plugin:GetOptionsPanel()
	return self.window.options;
end