PartyFrameOptionsField = class(Turbine.UI.Control);

function PartyFrameOptionsField:Constructor(parent, setting, label, w1, w2, h, outgoing, incoming)
	Turbine.UI.Control.Constructor(self);

	self.parent = parent;
	self.setting = setting;
	self.outgoing = outgoing;
	self.incoming = incoming;

	self:SetSize(w1 + w2, h);
	self:SetParent(parent);

	self.field = Turbine.UI.Lotro.TextBox();
	self.field.parent = self;
	self.field:SetSize(w1, h);
	self.field:SetPosition(0, 0);
	self.field:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	self.field:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.field.FocusGained = function(self, args)
		self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		self.value = self:GetText();
	end;
	self.field.FocusLost = function(self, args)
		self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
		self:SetText(self.value);
		self.value = nil;
	end;
	self.field.KeyDown = function(self, args)
		if args.Action == 162 then
			local x = self.parent.outgoing(self:GetText());

			if x ~= nil then
				self.parent.parent:SetSetting(self.parent.setting, x);
				self.parent.parent:Changed();
				self.parent:SetValue(x);
			end

			self.parent:Focus();
		end
	end;
	self.field:SetParent(self);

	self.label = Turbine.UI.Label();
	self.label:SetSize(w2, h);
	self.label:SetPosition(w1, 0);
	self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.label:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label:SetText(label);
	self.label:SetParent(self);
end

function PartyFrameOptionsField:SetValue(v)
	v = self.incoming(v);
	if self.field.value ~= nil then
		self.field.value = v;
	end
	self.field:SetText(v);
end